﻿Type=Class
Version=4.3
ModulesStructureVersion=1
B4A=true
@EndOfDesignText@
'Class module
Sub Class_Globals
	Private nativeMe As JavaObject
End Sub
'Initializes the object.
Public Sub Initialize
	nativeMe = Me
End Sub
'Adjust the Gamma value of an image (Gamma correction / encoding)
'Example:
'Dim ImageView1 As ImageView
'Dim mbu As BitmapUtilities
'Dim mBitmapImage As Bitmap
'
'mbu.Initialize
'
'mBitmapImage.Initialize(File.DirAssets,"your_picture.png")
'ImageView1.Bitmap = mbu.applyGammaEffect(mBitmapImage, 1.8, 1.8, 1.8) 
Public Sub applyGammaEffect(src As Bitmap, red As Double, green As Double, blue As Double) As Bitmap

src = nativeMe.RunMethod("applyGammaEffect", Array(src, red, green, blue))
Return src

End Sub

'Covert the bitmap to Greyscale
'Example:
'Dim ImageView1 As ImageView
'Dim mbu As BitmapUtilities
'Dim mBitmapImage As Bitmap
'
'mbu.Initialize
'
'mBitmapImage.Initialize(File.DirAssets,"your_picture.png")
'ImageView1.Bitmap = mbu.applyGreyscaleEffect(mBitmapImage) 
Public Sub applyGreyscaleEffect(src As Bitmap) As Bitmap

src = nativeMe.RunMethod("applyGreyscaleEffect", Array(src))
Return src

End Sub

'Invert the colors of a bitmap
'Example:
'Dim ImageView1 As ImageView
'Dim mbu As BitmapUtilities
'Dim mBitmapImage As Bitmap
'
'mbu.Initialize
'
'mBitmapImage.Initialize(File.DirAssets,"your_picture.png")
'ImageView1.Bitmap = mbu.applyInvertEffect(mBitmapImage) 
Public Sub applyInvertEffect(src As Bitmap) As Bitmap

src = nativeMe.RunMethod("applyInvertEffect", Array(src))
Return src

End Sub

'Highlighting a bitmap image 
'Example:
'Dim ImageView1 As ImageView
'Dim mbu As BitmapUtilities
'Dim mBitmapImage As Bitmap
'
'mbu.Initialize
'
'mBitmapImage.Initialize(File.DirAssets,"your_picture.png")
'ImageView1.Bitmap = mbu.applyHighlightEffect(mBitmapImage) 
Public Sub applyHighlightEffect(src As Bitmap) As Bitmap

src = nativeMe.RunMethod("applyHighlightEffect", Array(src))
Return src

End Sub
'Flip the bitmap image horizontally or vertically 
'Example:
'Dim ImageView1 As ImageView
'Dim mbu As BitmapUtilities
'Dim mBitmapImage As Bitmap
'
'mbu.Initialize
'
'Dim vertical, horizontal As Int
'vertical = 1
'horizontal = 2
'ImageView1.Bitmap = mbu.flipImage(mBitmapImage, horizontal) or 
'ImageView1.Bitmap = mbu.flipImage(mBitmapImage, vertical)
Public Sub flipImage(src As Bitmap, direction As Int) As Bitmap

src = nativeMe.RunMethod("flipImage", Array(src, direction))
Return src

End Sub
'Rotate the bitmap image through the number of degrees 
'Example:
'Dim ImageView1 As ImageView
'Dim mbu As BitmapUtilities
'Dim mBitmapImage As Bitmap
'
'mbu.Initialize
'
'Dim degree as Int
'degree = 270
'ImageView1.Bitmap = mbu.rotateImage(mBitmapImage, degree)
Public Sub rotateImage(src As Bitmap, degree As Int) As Bitmap

src = nativeMe.RunMethod("rotateImage", Array(src, degree))
Return src

End Sub
'Rotate the bitmap image through the number of degrees 
'Example:
'Dim ImageView1 As ImageView
'Dim mbu As BitmapUtilities
'Dim mBitmapImage As Bitmap
'
'mbu.Initialize
'
'Dim value as Double
'value = 50
'ImageView1.Bitmap = mbu.applyContrastEffect(mBitmapImage, value)
Public Sub applyContrastEffect(src As Bitmap, value As Double) As Bitmap

src = nativeMe.RunMethod("applyContrastEffect", Array(src, value))
Return src

End Sub
'Decrease the color depth of the bitmap image
'Example:
'Dim ImageView1 As ImageView
'Dim mbu As BitmapUtilities
'Dim mBitmapImage As Bitmap
'
'mbu.Initialize
'
'Dim depth as Int
'depth = 32
'ImageView1.Bitmap = mbu.applyDecreaseColorDepthEffect(mBitmapImage, depth)
Public Sub applyDecreaseColorDepthEffect(src As Bitmap, depth As Int) As Bitmap

src = nativeMe.RunMethod("applyDecreaseColorDepthEffect", Array(src, depth))
Return src

End Sub
'Create a Sepia Toning Effect
'Example:
'Dim ImageView1 As ImageView
'Dim mbu As BitmapUtilities
'Dim mBitmapImage As Bitmap
'
'mbu.Initialize
'
'Dim depth as Int
'depth = 24
'Dim red, green, blue as Double
'red = 3.0
'green = 0.0
'blue = 0.0
'ImageView1.Bitmap = mbu.applySepiaToningEffect(mBitmapImage, depth, red, green, blue)
Public Sub applySepiaToningEffect(src As Bitmap, depth As Int, red As Double, green As Double, blue As Double) As Bitmap

src = nativeMe.RunMethod("applySepiaToningEffect", Array(src, depth, red, green, blue))
Return src

End Sub
'Apply color filters
'Example:
'Dim ImageView1 As ImageView
'Dim mbu As BitmapUtilities
'Dim mBitmapImage As Bitmap
'
'mbu.Initialize
'
'Dim red, green, blue as Double
'red = 1.0
'green = 0.0
'blue = 0.0
'ImageView1.Bitmap = mbu.applyColorFilterEffect(mBitmapImage, depth, red, green, blue)
Public Sub applyColorFilterEffect(src As Bitmap, red As Double, green As Double, blue As Double) As Bitmap

src = nativeMe.RunMethod("applyColorFilterEffect", Array(src, red, green, blue))
Return src

End Sub

Public Sub drawRing(src As Bitmap, deltaRadius As Int, color As Int) As Bitmap

src = nativeMe.RunMethod("drawRing", Array(src, deltaRadius, color))
Return src

End Sub

Public Sub applyEmbossEffect(src As Bitmap) As Bitmap

src = nativeMe.RunMethod("applyEmbossEffect", Array(src))
Return src

End Sub

Public Sub applyEngraveEffect(src As Bitmap) As Bitmap

src = nativeMe.RunMethod("applyEngraveEffect", Array(src))
Return src

End Sub
Public Sub drawLayoutDropShadow(src As Bitmap) As Bitmap

src = nativeMe.RunMethod("drawLayoutDropShadow", Array(src))
Return src

End Sub
Public Sub squareImage(src As Bitmap) As Bitmap

src = nativeMe.RunMethod("squareImage", Array(src))
Return src

End Sub

Public Sub blur(src As Bitmap, radius As Int) As Bitmap

src = nativeMe.RunMethod("blur", Array(src, radius))
Return src

End Sub
Public Sub overlay(src As Bitmap, rotation As Float) As Bitmap

src = nativeMe.RunMethod("overlay", Array(src, rotation))
Return src

End Sub
Public Sub applyBrightnessEffect(src As Bitmap, value As Int) As Bitmap

src = nativeMe.RunMethod("applyBrightnessEffect", Array(src, value))
Return src

End Sub
Public Sub applyReflection(src As Bitmap) As Bitmap

src = nativeMe.RunMethod("applyReflection", Array(src))
Return src

End Sub

Public Sub applySnowEffect(src As Bitmap) As Bitmap

src = nativeMe.RunMethod("applySnowEffect", Array(src))
Return src

End Sub

Public Sub applyBlackFilter(src As Bitmap) As Bitmap

src = nativeMe.RunMethod("applyBlackFilter", Array(src))
Return src

End Sub

Public Sub applyFleaEffect(src As Bitmap) As Bitmap

src = nativeMe.RunMethod("applyFleaEffect", Array(src))
Return src

End Sub

Public Sub applyGaussianBlurEffect(src As Bitmap) As Bitmap

src = nativeMe.RunMethod("applyGaussianBlurEffect", Array(src))
Return src

End Sub

Public Sub applyMeanRemovalEffect(src As Bitmap) As Bitmap

src = nativeMe.RunMethod("applyMeanRemovalEffect", Array(src))
Return src

End Sub

Public Sub applySaturationFilter(src As Bitmap, level As Int) As Bitmap

src = nativeMe.RunMethod("applySaturationFilter", Array(src, level))
Return src

End Sub

Public Sub applyBoostEffect(src As Bitmap, a_type As Int, level As Double) As Bitmap

src = nativeMe.RunMethod("applyBoostEffect", Array(src, a_type, level))
Return src

End Sub

Public Sub applySharpenEffect(src As Bitmap, weight As Double) As Bitmap

src = nativeMe.RunMethod("applySharpenEffect", Array(src, weight))
Return src

End Sub
Public Sub applySmoothEffect(src As Bitmap, value As Double) As Bitmap

src = nativeMe.RunMethod("applySmoothEffect", Array(src, value))
Return src

End Sub

Public Sub applyHueFilter(src As Bitmap, level As Int) As Bitmap

src = nativeMe.RunMethod("applyHueFilter", Array(src, level))
Return src

End Sub
Public Sub toRoundCorner(src As Bitmap, color As Int) As Bitmap

src = nativeMe.RunMethod("toRoundCorner", Array(src, color))
Return src

End Sub
Public Sub toRounded(src As Bitmap, color As Int, borderDips As Int, desireWidth As Int) As Bitmap

src = nativeMe.RunMethod("toRounded", Array(src, color, borderDips, desireWidth))
Return src

End Sub

Public Sub drawRing2(src As Bitmap, deltaRadius As Int, color As Int, bordercolor As Int) As Bitmap

src = nativeMe.RunMethod("drawRing2", Array(src, deltaRadius, color, bordercolor))
Return src

End Sub

Public Sub getRoundBitmap(src As Bitmap, borderColor As Int, borderWidth As Int) As Bitmap

src = nativeMe.RunMethod("getRoundBitmap", Array(src, borderColor, borderWidth))
Return src

End Sub

Public Sub applyShadingFilter(src As Bitmap, shadingColor As Int) As Bitmap

src = nativeMe.RunMethod("applyShadingFilter", Array(src, shadingColor))
Return src

End Sub

Public Sub applyTintEffect(src As Bitmap, degree As Int) As Bitmap

src = nativeMe.RunMethod("applyTintEffect", Array(src, degree))
Return src

End Sub

Public Sub applyRoundCornerEffect(src As Bitmap, aRound As Float) As Bitmap

src = nativeMe.RunMethod("applyRoundCornerEffect", Array(src, aRound))
Return src

End Sub

Public Sub applyWaterMarkEffect(src As Bitmap, watermark As String, x As Int, y As Int, color As Int, alpha As Int, size As Int, underline As Boolean) As Bitmap

src = nativeMe.RunMethod("applyWaterMarkEffect", Array(src, watermark, x, y, color, alpha, size, underline))
Return src

End Sub

Public Sub getHexagonShape(src As Bitmap) As Bitmap

src = nativeMe.RunMethod("getHexagonShape", Array(src))
Return src

End Sub

Public Sub getTriangleShape(src As Bitmap) As Bitmap

src = nativeMe.RunMethod("getTriangleShape", Array(src))
Return src

End Sub

Public Sub getBubbleBitmap(src As Bitmap) As Bitmap

src = nativeMe.RunMethod("getBubbleBitmap", Array(src))
Return src

End Sub

Public Sub getConeBitmap(src As Bitmap) As Bitmap

src = nativeMe.RunMethod("getConeBitmap", Array(src))
Return src

End Sub

Public Sub getStarBitmap(src As Bitmap, steps As Int) As Bitmap

src = nativeMe.RunMethod("getStarBitmap", Array(src, steps))
Return src

End Sub

Public Sub getHeartBitmap(src As Bitmap) As Bitmap

src = nativeMe.RunMethod("getHeartBitmap", Array(src))
Return src

End Sub

Public Sub getCircledStar(src As Bitmap) As Bitmap

src = nativeMe.RunMethod("getCircledStar", Array(src))
Return src

End Sub



#If Java

import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.graphics.Color;
import android.graphics.Paint;
import android.view.View;
import android.graphics.Canvas;
import android.graphics.PorterDuff;
import android.graphics.PorterDuffXfermode;
import android.graphics.BlurMaskFilter;
import android.graphics.Matrix;
import android.graphics.RectF;
import android.graphics.drawable.Drawable;
import android.graphics.drawable.BitmapDrawable;
import android.graphics.drawable.GradientDrawable;
import android.graphics.Bitmap.Config;
import android.graphics.Path;
import android.graphics.Path.FillType;
import android.graphics.Rect;
import android.graphics.RectF;
import android.content.res.Resources;
import android.content.Context;
import android.content.res.AssetManager;
import android.util.DisplayMetrics;
import android.util.TypedValue;
import android.graphics.LinearGradient;
import android.graphics.Shader;
import android.graphics.BitmapShader;


import java.io.BufferedOutputStream;
import java.io.File;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStream;

import android.annotation.TargetApi;
import android.graphics.BitmapFactory.Options;
import android.graphics.PorterDuff.Mode;
import android.media.ExifInterface;
import android.media.ThumbnailUtils;
import android.os.Build;
import android.os.Build.VERSION;
import android.os.Build.VERSION_CODES;
import android.provider.MediaStore.Images;
import android.text.TextUtils;
import android.view.Gravity;
import java.util.Random;
import android.widget.ImageView;


    //Gamma Image (R, G, B) = (1.8, 1.8, 1.8)
    public Bitmap applyGammaEffect(Bitmap src, double red, double green, double blue) {
        // create output image
        Bitmap bmOut = Bitmap.createBitmap(src.getWidth(), src.getHeight(), src.getConfig());
        // get image size
        int width = src.getWidth();
        int height = src.getHeight();
        // color information
        int A, R, G, B;
        int pixel;
        // constant value curve
        final int MAX_SIZE = 256;
        final double MAX_VALUE_DBL = 255.0;
        final int MAX_VALUE_INT = 255;
        final double REVERSE = 1.0;

        // gamma arrays
        int[] gammaR = new int[MAX_SIZE];
        int[] gammaG = new int[MAX_SIZE];
        int[] gammaB = new int[MAX_SIZE];

        // setting values for every gamma channels
        for (int i = 0; i < MAX_SIZE; ++i) {
            gammaR[i] = (int) Math.min(MAX_VALUE_INT,
                    (int) ((MAX_VALUE_DBL * Math.pow(i / MAX_VALUE_DBL, REVERSE / red)) + 0.5));
            gammaG[i] = (int) Math.min(MAX_VALUE_INT,
                    (int) ((MAX_VALUE_DBL * Math.pow(i / MAX_VALUE_DBL, REVERSE / green)) + 0.5));
            gammaB[i] = (int) Math.min(MAX_VALUE_INT,
                    (int) ((MAX_VALUE_DBL * Math.pow(i / MAX_VALUE_DBL, REVERSE / blue)) + 0.5));
        }

        // apply gamma table
        for (int x = 0; x < width; ++x) {
            for (int y = 0; y < height; ++y) {
                // get pixel color
                pixel = src.getPixel(x, y);
                A = Color.alpha(pixel);
                // look up gamma
                R = gammaR[Color.red(pixel)];
                G = gammaG[Color.green(pixel)];
                B = gammaB[Color.blue(pixel)];
                // set new color to output bitmap
                bmOut.setPixel(x, y, Color.argb(A, R, G, B));
            }
        }

        // return final image
        return bmOut;
    }	

    public Bitmap applyGreyscaleEffect(Bitmap src) {
        // constant factors
        final double GS_RED = 0.299;
        final double GS_GREEN = 0.587;
        final double GS_BLUE = 0.114;

        // create output bitmap
        Bitmap bmOut = Bitmap.createBitmap(src.getWidth(), src.getHeight(), src.getConfig());
        // pixel information
        int A, R, G, B;
        int pixel;

        // get image size
        int width = src.getWidth();
        int height = src.getHeight();

        // scan through every single pixel
        for (int x = 0; x < width; ++x) {
            for (int y = 0; y < height; ++y) {
                // get one pixel color
                pixel = src.getPixel(x, y);
                // retrieve color of all channels
                A = Color.alpha(pixel);
                R = Color.red(pixel);
                G = Color.green(pixel);
                B = Color.blue(pixel);
                // take conversion up to one single value
                R = G = B = (int) (GS_RED * R + GS_GREEN * G + GS_BLUE * B);
                // set new pixel color to output bitmap
                bmOut.setPixel(x, y, Color.argb(A, R, G, B));
            }
        }

        // return final image
        return bmOut;
    }

    public Bitmap applyInvertEffect(Bitmap src) {
        // create new bitmap with the same settings as source bitmap
        Bitmap bmOut = Bitmap.createBitmap(src.getWidth(), src.getHeight(), src.getConfig());
        // color info
        int A, R, G, B;
        int pixelColor;
        // image size
        int height = src.getHeight();
        int width = src.getWidth();

        // scan through every pixel
        for (int y = 0; y < height; y++) {
            for (int x = 0; x < width; x++) {
                // get one pixel
                pixelColor = src.getPixel(x, y);
                // saving alpha channel
                A = Color.alpha(pixelColor);
                // inverting byte for each R/G/B channel
                R = 255 - Color.red(pixelColor);
                G = 255 - Color.green(pixelColor);
                B = 255 - Color.blue(pixelColor);
                // set newly-inverted pixel to output image
                bmOut.setPixel(x, y, Color.argb(A, R, G, B));
            }
        }

        // return final bitmap
        return bmOut;
    }

    public Bitmap applyHighlightEffect(Bitmap src) {

        // create new bitmap, which will be painted and becomes result image
        Bitmap bmOut = Bitmap.createBitmap(src.getWidth(), src.getHeight(), Bitmap.Config.ARGB_8888);
        // setup canvas for painting
        Canvas canvas = new Canvas(bmOut);
        // setup default color
        canvas.drawColor(0, PorterDuff.Mode.CLEAR);

        // create a blur paint for capturing alpha
        Paint ptBlur = new Paint();
        ptBlur.setMaskFilter(new BlurMaskFilter(15, BlurMaskFilter.Blur.NORMAL));
        int[] offsetXY = new int[2];
        // capture alpha into a bitmap
        Bitmap bmAlpha = src.extractAlpha(ptBlur, offsetXY);
        // create a color paint
        Paint ptAlphaColor = new Paint();
        ptAlphaColor.setColor(0xFFFFFFFF);
        // paint color for captured alpha region (bitmap)
        canvas.drawBitmap(bmAlpha, offsetXY[0], offsetXY[1], ptAlphaColor);
        // free memory
        bmAlpha.recycle();

        // paint the image source
        canvas.drawBitmap(src, 0, 0, null);

        // return out final image
        return bmOut;
    }

public Bitmap flipImage(Bitmap src, int type) {
    // create new matrix for transformation
    Matrix matrix = new Matrix();
    // if vertical
    if(type == 1) {
        // y = y * -1
        matrix.preScale(1.0f, -1.0f);
    }
    // if horizonal
    else if(type == 2) {
        // x = x * -1
        matrix.preScale(-1.0f, 1.0f);
    // unknown type
    } else {
        return null;
    }
 
    // return transformed image
    return Bitmap.createBitmap(src, 0, 0, src.getWidth(), src.getHeight(), matrix, true);
}

	public Bitmap rotateImage(Bitmap bitmap, int rotate) {
		if (bitmap == null) {
			return bitmap;
		}
		Matrix matrix = new Matrix();
		matrix.setRotate(rotate);
		Bitmap rotated = Bitmap.createBitmap(bitmap, 0, 0, bitmap.getWidth(),
				bitmap.getHeight(), matrix, true);
		if (rotated != null && !rotated.equals(bitmap)) {
//			bitmap.recycle();
			bitmap = rotated;
		}
		return bitmap;
	}

    public  Bitmap applyContrastEffect(Bitmap src, double value) {
        // image size
        int width = src.getWidth();
        int height = src.getHeight();
        // create output bitmap
        Bitmap bmOut = Bitmap.createBitmap(width, height, src.getConfig());
        // color information
        int A, R, G, B;
        int pixel;
        // get contrast value
        double contrast = Math.pow((100 + value) / 100, 2);

        // scan through all pixels
        for(int x = 0; x < width; ++x) {
            for(int y = 0; y < height; ++y) {
                // get pixel color
                pixel = src.getPixel(x, y);
                A = Color.alpha(pixel);
                // apply filter contrast for every channel R, G, B
                R = Color.red(pixel);
                R = (int)(((((R / 255.0) - 0.5) * contrast) + 0.5) * 255.0);
                if(R < 0) { R = 0; }
                else if(R > 255) { R = 255; }

                G = Color.red(pixel);
                G = (int)(((((G / 255.0) - 0.5) * contrast) + 0.5) * 255.0);
                if(G < 0) { G = 0; }
                else if(G > 255) { G = 255; }

                B = Color.red(pixel);
                B = (int)(((((B / 255.0) - 0.5) * contrast) + 0.5) * 255.0);
                if(B < 0) { B = 0; }
                else if(B > 255) { B = 255; }

                // set new pixel color to output bitmap
                bmOut.setPixel(x, y, Color.argb(A, R, G, B));
            }
        }

        // return final image
        return bmOut;
    }

    public  Bitmap applyDecreaseColorDepthEffect(Bitmap src, int bitOffset) {
        // get image size
        int width = src.getWidth();
        int height = src.getHeight();
        // create output bitmap
        Bitmap bmOut = Bitmap.createBitmap(width, height, src.getConfig());
        // color information
        int A, R, G, B;
        int pixel;

        // scan through all pixels
        for(int x = 0; x < width; ++x) {
            for(int y = 0; y < height; ++y) {
                // get pixel color
                pixel = src.getPixel(x, y);
                A = Color.alpha(pixel);
                R = Color.red(pixel);
                G = Color.green(pixel);
                B = Color.blue(pixel);

                // round-off color offset
                R = ((R + (bitOffset / 2)) - ((R + (bitOffset / 2)) % bitOffset) - 1);
                if(R < 0) { R = 0; }
                G = ((G + (bitOffset / 2)) - ((G + (bitOffset / 2)) % bitOffset) - 1);
                if(G < 0) { G = 0; }
                B = ((B + (bitOffset / 2)) - ((B + (bitOffset / 2)) % bitOffset) - 1);
                if(B < 0) { B = 0; }

                // set pixel color to output bitmap
                bmOut.setPixel(x, y, Color.argb(A, R, G, B));
            }
        }

        // return final image
        return bmOut;
    }

    public  Bitmap applySepiaToningEffect(Bitmap src, int depth, double red, double green, double blue) {
        // image size
        int width = src.getWidth();
        int height = src.getHeight();
        // create output bitmap
        Bitmap bmOut = Bitmap.createBitmap(width, height, src.getConfig());
        // constant grayscale
        final double GS_RED = 0.3;
        final double GS_GREEN = 0.59;
        final double GS_BLUE = 0.11;
        // color information
        int A, R, G, B;
        int pixel;

        // scan through all pixels
        for(int x = 0; x < width; ++x) {
            for(int y = 0; y < height; ++y) {
                // get pixel color
                pixel = src.getPixel(x, y);
                // get color on each channel
                A = Color.alpha(pixel);
                R = Color.red(pixel);
                G = Color.green(pixel);
                B = Color.blue(pixel);
                // apply grayscale sample
                B = G = R = (int)(GS_RED * R + GS_GREEN * G + GS_BLUE * B);

                // apply intensity level for sepia-toning on each channel
                R += (depth * red);
                if(R > 255) { R = 255; }

                G += (depth * green);
                if(G > 255) { G = 255; }

                B += (depth * blue);
                if(B > 255) { B = 255; }

                // set new pixel color to output image
                bmOut.setPixel(x, y, Color.argb(A, R, G, B));
            }
        }

        // return final image
        return bmOut;
    }
	
    public Bitmap applyColorFilterEffect(Bitmap src, double red, double green, double blue) {
        // image size
        int width = src.getWidth();
        int height = src.getHeight();
        // create output bitmap
        Bitmap bmOut = Bitmap.createBitmap(width, height, src.getConfig());
        // color information
        int A, R, G, B;
        int pixel;

        // scan through all pixels
        for (int x = 0; x < width; ++x) {
            for (int y = 0; y < height; ++y) {
                // get pixel color
                pixel = src.getPixel(x, y);
                // apply filtering on each channel R, G, B
                A = Color.alpha(pixel);
                R = (int) (Color.red(pixel) * red);
                G = (int) (Color.green(pixel) * green);
                B = (int) (Color.blue(pixel) * blue);
                // set new color pixel to output bitmap
                bmOut.setPixel(x, y, Color.argb(A, R, G, B));
            }
        }

        // return final image
        return bmOut;
    }	
	
	public Bitmap drawRing(Bitmap bitmap, int deltaRadius,
			int color) {
		bitmap = squareImage(bitmap);	
		int w = bitmap.getWidth();
		int dia = deltaRadius * 2 + w;
		float radius = (float) dia / 2;
		Bitmap resultBitmap = Bitmap.createBitmap(dia, dia, Config.ARGB_8888);
		Paint paint = new Paint();
		paint.setColor(color);
		paint.setAlpha(128);
		paint.setAntiAlias(true);
		Canvas canvas = new Canvas(resultBitmap);
		canvas.drawCircle(radius, radius, radius, paint);
		canvas.drawBitmap(bitmap, deltaRadius, deltaRadius, null);
		return resultBitmap;
	}	

    public  Bitmap applyEmbossEffect(Bitmap src) {
        double[][] EmbossConfig = new double[][] {
                { -1 ,  0, -1 },
                {  0 ,  4,  0 },
                { -1 ,  0, -1 }
        };
        ConvolutionMatrix(3);
        applyConfig(EmbossConfig);
        Factor = 1;
        Offset = 127;
        return computeConvolution3x3(src);
    }	
	
    public  Bitmap applyEngraveEffect(Bitmap src) {
        ConvolutionMatrix(3);
        setAll(0);
        Matrix[0][0] = -2;
        Matrix[1][1] = 2;
        Factor = 1;
        Offset = 95;
        return computeConvolution3x3(src);
    }
	
	public static Bitmap drawLayoutDropShadow(Bitmap bitmap) {
		BlurMaskFilter blurFilter = new BlurMaskFilter(10,
				BlurMaskFilter.Blur.NORMAL);
		Paint shadowPaint = new Paint();
		shadowPaint.setMaskFilter(blurFilter);
		int[] offsetXY = { 5, 5 };
		Bitmap shadowBitmap = bitmap.extractAlpha(shadowPaint, offsetXY);
		Bitmap shadowImage32 = shadowBitmap.copy(Bitmap.Config.ARGB_8888, true);
		Canvas c = new Canvas(shadowImage32);
		c.drawBitmap(bitmap, 0, 0, null);
		return shadowImage32;
	}	

	public Bitmap squareImage(Bitmap bitmap) {
		if (bitmap == null) {
			return null;
		}
		int width = bitmap.getWidth();
		int height = bitmap.getHeight();
		if (width == height) {
			BA.Log("no need to square image");
			return bitmap;
		}
		int x = (height < width) ? ((width - height) / 2) : 0;
		int y = (width < height) ? ((height - width) / 2) : 0;
		int pixels = width < height ? width : height;
		Bitmap square = Bitmap.createBitmap(bitmap, x, y, pixels, pixels);
		return square;
	}

	public Bitmap blur(Bitmap bmp, int radius) {
		int iterations = 1;
		int width = bmp.getWidth();
		int height = bmp.getHeight();
		int[] inPixels = new int[width * height];
		int[] outPixels = new int[width * height];
		Bitmap bitmap = Bitmap.createBitmap(width, height,
				Bitmap.Config.ARGB_8888);
		bmp.getPixels(inPixels, 0, width, 0, 0, width, height);
		for (int i = 0; i < iterations; i++) {
			blur(inPixels, outPixels, width, height, radius);
			blur(outPixels, inPixels, height, width, radius);
		}
		bitmap.setPixels(inPixels, 0, width, 0, 0, width, height);
		return bitmap;
	}
	
	public Bitmap overlay(Bitmap bitmap, float rota) {
	    bitmap = squareImage(bitmap);
		if (bitmap == null) {
			return null;
		}
		int width = bitmap.getWidth();
		int height = bitmap.getHeight();
		if (width == 0 || height == 0) {
			return null;
		}
//		float rota = 330;
		double radians = Math.toRadians(rota);
		/* after rotate , the new width is the original width */
		int rotateWidth = (int) (width / (Math.abs(Math.sin(radians)) + Math
				.abs(Math.cos(radians))));
		int delta = (width - rotateWidth) / 2;

		// result
		Bitmap result = Bitmap.createBitmap(width, width, Config.ARGB_8888);
		Canvas canvas = new Canvas(result);
		// foreground
		Bitmap foreBmp = resizeImage(bitmap, rotateWidth, rotateWidth, true);
		// rotate
		Matrix matrix = new Matrix();
		matrix.postRotate(rota);
		Bitmap rotate = Bitmap.createBitmap(foreBmp, 0, 0, rotateWidth,
				rotateWidth, matrix, true);
		canvas.drawBitmap(rotate, 0, 0, null);
		canvas.drawBitmap(foreBmp, delta, delta, null);
		return result;
	}	
	
    public  Bitmap applyBrightnessEffect(Bitmap src, int value) {
        // image size
        int width = src.getWidth();
        int height = src.getHeight();
        // create output bitmap
        Bitmap bmOut = Bitmap.createBitmap(width, height, src.getConfig());
        // color information
        int A, R, G, B;
        int pixel;

        // scan through all pixels
        for(int x = 0; x < width; ++x) {
            for(int y = 0; y < height; ++y) {
                // get pixel color
                pixel = src.getPixel(x, y);
                A = Color.alpha(pixel);
                R = Color.red(pixel);
                G = Color.green(pixel);
                B = Color.blue(pixel);

                // increase/decrease each channel
                R += value;
                if(R > 255) { R = 255; }
                else if(R < 0) { R = 0; }

                G += value;
                if(G > 255) { G = 255; }
                else if(G < 0) { G = 0; }

                B += value;
                if(B > 255) { B = 255; }
                else if(B < 0) { B = 0; }

                // apply new pixel color to output bitmap
                bmOut.setPixel(x, y, Color.argb(A, R, G, B));
            }
        }

        // return final image
        return bmOut;
    }	
	
    public  Bitmap applyReflection(Bitmap originalImage) {
        // gap space between original and reflected
        final int reflectionGap = 4;
        // get image size
        int width = originalImage.getWidth();
        int height = originalImage.getHeight();

        // this will not scale but will flip on the Y axis
        Matrix matrix = new Matrix();
        matrix.preScale(1, -1);

        // create a Bitmap with the flip matrix applied to it.
        // we only want the bottom half of the image
        Bitmap reflectionImage = Bitmap.createBitmap(originalImage, 0, height/2, width, height/2, matrix, false);

        // create a new bitmap with same width but taller to fit reflection
        Bitmap bitmapWithReflection = Bitmap.createBitmap(width, (height + height/2), Bitmap.Config.ARGB_8888);

        // create a new Canvas with the bitmap that's big enough for
        // the image plus gap plus reflection
        Canvas canvas = new Canvas(bitmapWithReflection);
        // draw in the original image
        canvas.drawBitmap(originalImage, 0, 0, null);
        // draw in the gap
        Paint defaultPaint = new Paint();
        canvas.drawRect(0, height, width, height + reflectionGap, defaultPaint);
        // draw in the reflection
        canvas.drawBitmap(reflectionImage,0, height + reflectionGap, null);

        // create a shader that is a linear gradient that covers the reflection
        Paint paint = new Paint();
        LinearGradient shader = new LinearGradient(0, originalImage.getHeight(), 0,
                bitmapWithReflection.getHeight() + reflectionGap, 0x70ffffff, 0x00ffffff,
                Shader.TileMode.CLAMP);
        // set the paint to use this shader (linear gradient)
        paint.setShader(shader);
        // set the Transfer mode to be porter duff and destination in
        paint.setXfermode(new PorterDuffXfermode(PorterDuff.Mode.DST_IN));
        // draw a rectangle using the paint with our linear gradient
        canvas.drawRect(0, height, width, bitmapWithReflection.getHeight() + reflectionGap, paint);

        return bitmapWithReflection;
    }	
	
    public  Bitmap applySnowEffect(Bitmap source) {
        // get image size
        int width = source.getWidth();
        int height = source.getHeight();
        int[] pixels = new int[width * height];
        // get pixel array from source
        source.getPixels(pixels, 0, width, 0, 0, width, height);
        // random object
        Random random = new Random();

        int R, G, B, index = 0, thresHold = 50;
        // iteration through pixels
        for(int y = 0; y < height; ++y) {
            for(int x = 0; x < width; ++x) {
                // get current index in 2D-matrix
                index = y * width + x;
                // get color
                R = Color.red(pixels[index]);
                G = Color.green(pixels[index]);
                B = Color.blue(pixels[index]);
                // generate threshold
                thresHold = random.nextInt(0xFF);
                if(R > thresHold && G > thresHold && B > thresHold) {
                    pixels[index] = Color.rgb(0xFF, 0xFF, 0xFF);
                }
            }
        }
        // output bitmap
        Bitmap bmOut = Bitmap.createBitmap(width, height, Bitmap.Config.RGB_565);
        bmOut.setPixels(pixels, 0, width, 0, 0, width, height);
        return bmOut;
    }	
	

    public  Bitmap applyBlackFilter(Bitmap source) {
        // get image size
        int width = source.getWidth();
        int height = source.getHeight();
        int[] pixels = new int[width * height];
        // get pixel array from source
        source.getPixels(pixels, 0, width, 0, 0, width, height);
        // random object
        Random random = new Random();

        int R, G, B, index = 0, thresHold = 0;
        // iteration through pixels
        for(int y = 0; y < height; ++y) {
            for(int x = 0; x < width; ++x) {
                // get current index in 2D-matrix
                index = y * width + x;
                // get color
                R = Color.red(pixels[index]);
                G = Color.green(pixels[index]);
                B = Color.blue(pixels[index]);
                // generate threshold
                thresHold = random.nextInt(0xFF);
                if(R < thresHold && G < thresHold && B < thresHold) {
                    pixels[index] = Color.rgb(0x00, 0x00, 0x00);
                }
            }
        }
        // output bitmap
        Bitmap bmOut = Bitmap.createBitmap(width, height, Bitmap.Config.ARGB_8888);
        bmOut.setPixels(pixels, 0, width, 0, 0, width, height);
        return bmOut;
    }	
	
    public  Bitmap applyFleaEffect(Bitmap source) {
        // get image size
        int width = source.getWidth();
        int height = source.getHeight();
        int[] pixels = new int[width * height];
        // get pixel array from source
        source.getPixels(pixels, 0, width, 0, 0, width, height);
        // a random object
        Random random = new Random();

        int index = 0;
        // iteration through pixels
        for(int y = 0; y < height; ++y) {
            for(int x = 0; x < width; ++x) {
                // get current index in 2D-matrix
                index = y * width + x;
                // get random color
                int randColor = Color.rgb(random.nextInt(0xFF),
                        random.nextInt(0xFF), random.nextInt(0xFF));
                // OR
                pixels[index] |= randColor;
            }
        }
        // output bitmap
        Bitmap bmOut = Bitmap.createBitmap(width, height, source.getConfig());
        bmOut.setPixels(pixels, 0, width, 0, 0, width, height);
        return bmOut;
    }		

    public Bitmap applyGaussianBlurEffect(Bitmap src) {
        double[][] GaussianBlurConfig = new double[][] {
                { 1, 2, 1 },
                { 2, 4, 2 },
                { 1, 2, 1 }
        };
        ConvolutionMatrix(3);
        applyConfig(GaussianBlurConfig);
        Factor = 16;
        Offset = 0;
        return computeConvolution3x3(src);
    }
	
    public  Bitmap applyMeanRemovalEffect(Bitmap src) {
        double[][] MeanRemovalConfig = new double[][] {
                { -1 , -1, -1 },
                { -1 ,  9, -1 },
                { -1 , -1, -1 }
        };
        ConvolutionMatrix(3);
        applyConfig(MeanRemovalConfig);
        Factor = 1;
        Offset = 0;
        return computeConvolution3x3(src);
    }	
	
    public  Bitmap applySaturationFilter(Bitmap source, int level) {
        // get image size
        int width = source.getWidth();
        int height = source.getHeight();
        int[] pixels = new int[width * height];
        float[] HSV = new float[3];
        // get pixel array from source
        source.getPixels(pixels, 0, width, 0, 0, width, height);

        int index = 0;
        // iteration through pixels
        for(int y = 0; y < height; ++y) {
            for(int x = 0; x < width; ++x) {
                // get current index in 2D-matrix
                index = y * width + x;
                // convert to HSV
                Color.colorToHSV(pixels[index], HSV);
                // increase Saturation level
                HSV[1] *= level;
                HSV[1] = (float) Math.max(0.0, Math.min(HSV[1], 1.0));
                // take color back
                pixels[index] |= Color.HSVToColor(HSV);
            }
        }
        // output bitmap
        Bitmap bmOut = Bitmap.createBitmap(width, height, Bitmap.Config.ARGB_8888);
        bmOut.setPixels(pixels, 0, width, 0, 0, width, height);
        return bmOut;
    }		
	
    public  Bitmap applyBoostEffect(Bitmap src, int type, double percent) {
        int width = src.getWidth();
        int height = src.getHeight();
        Bitmap bmOut = Bitmap.createBitmap(width, height, src.getConfig());

        int A, R, G, B;
        int pixel;

        for(int x = 0; x < width; ++x) {
            for(int y = 0; y < height; ++y) {
                pixel = src.getPixel(x, y);
                A = Color.alpha(pixel);
                R = Color.red(pixel);
                G = Color.green(pixel);
                B = Color.blue(pixel);
                if(type == 1) {
                    R = (int)(R * (1 + percent));
                    if(R > 255) R = 255;
                }
                else if(type == 2) {
                    G = (int)(G * (1 + percent));
                    if(G > 255) G = 255;
                }
                else if(type == 3) {
                    B = (int)(B * (1 + percent));
                    if(B > 255) B = 255;
                }
                bmOut.setPixel(x, y, Color.argb(A, R, G, B));
            }
        }
        return bmOut;
    }		
	
    public  Bitmap applySharpenEffect(Bitmap src, double weight) {
        double[][] SharpConfig = new double[][] {
                { 0 , -2    , 0  },
                { -2, weight, -2 },
                { 0 , -2    , 0  }
        };
        ConvolutionMatrix(3);
        applyConfig(SharpConfig);
        Factor = weight - 8;
        return computeConvolution3x3(src);
    }		
	
    public Bitmap applySmoothEffect(Bitmap src, double value) {
        ConvolutionMatrix(3);
        setAll(1);
        Matrix[1][1] = value;
        Factor = value + 8;
        Offset = 1;
        return computeConvolution3x3(src);
    }		

    public  Bitmap applyHueFilter(Bitmap source, int level) {
        // get image size
        int width = source.getWidth();
        int height = source.getHeight();
        int[] pixels = new int[width * height];
        float[] HSV = new float[3];
        // get pixel array from source
        source.getPixels(pixels, 0, width, 0, 0, width, height);

        int index = 0;
        // iteration through pixels
        for(int y = 0; y < height; ++y) {
            for(int x = 0; x < width; ++x) {
                // get current index in 2D-matrix
                index = y * width + x;
                // convert to HSV
                Color.colorToHSV(pixels[index], HSV);
                // increase Saturation level
                HSV[0] *= level;
                HSV[0] = (float) Math.max(0.0, Math.min(HSV[0], 360.0));
                // take color back
                pixels[index] |= Color.HSVToColor(HSV);
            }
        }
        // output bitmap
        Bitmap bmOut = Bitmap.createBitmap(width, height, Bitmap.Config.ARGB_8888);
        bmOut.setPixels(pixels, 0, width, 0, 0, width, height);
        return bmOut;
    }


	public Bitmap resizeImage(Bitmap bitmap, int desireWidth,
			int desireHeight, boolean isEnlarge) {
		if (bitmap == null || desireHeight <= 0 || desireWidth <= 0) {
			return null;
		}

		int width = bitmap.getWidth();
		int height = bitmap.getHeight();

		if (width <= 0 || height <= 0) {
			return bitmap;
		}
		if (!isEnlarge && (width < desireWidth && height < desireHeight)) {
			return bitmap;
		}
		float scale;
		if (width < height) {
			scale = (float) desireHeight / (float) height;
			if (desireWidth < width * scale) {
				scale = (float) desireWidth / (float) width;
			}
		} else {
			scale = (float) desireWidth / (float) width;
		}

		Matrix matrix = new Matrix();
		matrix.postScale(scale, scale);
		bitmap = Bitmap.createBitmap(bitmap, 0, 0, width, height, matrix, true);

		return bitmap;
	}

	
	public void blur(int[] in, int[] out, int width, int height,
			int radius) {
		int widthMinus1 = width - 1;
		int tableSize = 2 * radius + 1;
		int divide[] = new int[256 * tableSize];

		for (int index = 0; index < 256 * tableSize; index++) {
			divide[index] = index / tableSize;
		}

		int inIndex = 0;

		for (int y = 0; y < height; y++) {
			int outIndex = y;
			int ta = 0, tr = 0, tg = 0, tb = 0;

			for (int i = -radius; i <= radius; i++) {
				int rgb = in[inIndex + clamp(i, 0, width - 1)];
				ta += (rgb >> 24) & 0xff;
				tr += (rgb >> 16) & 0xff;
				tg += (rgb >> 8) & 0xff;
				tb += rgb & 0xff;
			}

			for (int x = 0; x < width; x++) {
				out[outIndex] = (divide[ta] << 24) | (divide[tr] << 16)
						| (divide[tg] << 8) | divide[tb];

				int i1 = x + radius + 1;
				if (i1 > widthMinus1)
					i1 = widthMinus1;
				int i2 = x - radius;
				if (i2 < 0)
					i2 = 0;
				int rgb1 = in[inIndex + i1];
				int rgb2 = in[inIndex + i2];

				ta += ((rgb1 >> 24) & 0xff) - ((rgb2 >> 24) & 0xff);
				tr += ((rgb1 & 0xff0000) - (rgb2 & 0xff0000)) >> 16;
				tg += ((rgb1 & 0xff00) - (rgb2 & 0xff00)) >> 8;
				tb += (rgb1 & 0xff) - (rgb2 & 0xff);
				outIndex += height;
			}
			inIndex += width;
		}
	}

	public int clamp(int x, int a, int b) {
		return (x < a) ? a : (x > b) ? b : x;
	}

    public  Bitmap applyWaterMarkEffect(Bitmap src, String watermark, int x,int y, int color, int alpha, int size, boolean underline) {
        int w = src.getWidth();
        int h = src.getHeight();
        Bitmap result = Bitmap.createBitmap(w, h, src.getConfig());

        Canvas canvas = new Canvas(result);
        canvas.drawBitmap(src, 0, 0, null);

        Paint paint = new Paint();
        paint.setColor(color);
        paint.setAlpha(alpha);
        paint.setTextSize(size);
        paint.setAntiAlias(true);
        paint.setUnderlineText(underline);
        canvas.drawText(watermark, x, y, paint);

        return result;
    }
		
	    public Bitmap applyRoundCornerEffect(Bitmap src, float round) {
        // image size
        int width = src.getWidth();
        int height = src.getHeight();
        // create bitmap output
        Bitmap result = Bitmap.createBitmap(width, height, Bitmap.Config.ARGB_8888);
        // set canvas for painting
        Canvas canvas = new Canvas(result);
        canvas.drawARGB(0, 0, 0, 0);

        // config paint
        final Paint paint = new Paint();
        paint.setAntiAlias(true);
        paint.setColor(Color.BLACK);

        // config rectangle for embedding
        final Rect rect = new Rect(0, 0, width, height);
        final RectF rectF = new RectF(rect);

        // draw rect to canvas
        canvas.drawRoundRect(rectF, round, round, paint);

        // create Xfer mode
        paint.setXfermode(new PorterDuffXfermode(PorterDuff.Mode.SRC_IN));
        // draw source image to canvas
        canvas.drawBitmap(src, rect, rect, paint);

        // return final image
        return result;
    }
	
	
    public static final double PI = 3.14159d;
    public static final double FULL_CIRCLE_DEGREE = 360d;
    public static final double HALF_CIRCLE_DEGREE = 180d;
    public static final double RANGE = 256d;

    public  Bitmap applyTintEffect(Bitmap src, int degree) {

        int width = src.getWidth();
        int height = src.getHeight();

        int[] pix = new int[width * height];
        src.getPixels(pix, 0, width, 0, 0, width, height);

        int RY, GY, BY, RYY, GYY, BYY, R, G, B, Y;
        double angle = (PI * (double)degree) / HALF_CIRCLE_DEGREE;

        int S = (int)(RANGE * Math.sin(angle));
        int C = (int)(RANGE * Math.cos(angle));

        for (int y = 0; y < height; y++)
            for (int x = 0; x < width; x++) {
                int index = y * width + x;
                int r = ( pix[index] >> 16 ) & 0xff;
                int g = ( pix[index] >> 8 ) & 0xff;
                int b = pix[index] & 0xff;
                RY = ( 70 * r - 59 * g - 11 * b ) / 100;
                GY = (-30 * r + 41 * g - 11 * b ) / 100;
                BY = (-30 * r - 59 * g + 89 * b ) / 100;
                Y  = ( 30 * r + 59 * g + 11 * b ) / 100;
                RYY = ( S * BY + C * RY ) / 256;
                BYY = ( C * BY - S * RY ) / 256;
                GYY = (-51 * RYY - 19 * BYY ) / 100;
                R = Y + RYY;
                R = ( R < 0 ) ? 0 : (( R > 255 ) ? 255 : R );
                G = Y + GYY;
                G = ( G < 0 ) ? 0 : (( G > 255 ) ? 255 : G );
                B = Y + BYY;
                B = ( B < 0 ) ? 0 : (( B > 255 ) ? 255 : B );
                pix[index] = 0xff000000 | (R << 16) | (G << 8 ) | B;
            }

        Bitmap outBitmap = Bitmap.createBitmap(width, height, src.getConfig());
        outBitmap.setPixels(pix, 0, width, 0, 0, width, height);

        pix = null;

        return outBitmap;
    }	
	

    public Bitmap applyShadingFilter(Bitmap source, int shadingColor) {
        // get image size
        int width = source.getWidth();
        int height = source.getHeight();
        int[] pixels = new int[width * height];
        // get pixel array from source
        source.getPixels(pixels, 0, width, 0, 0, width, height);

        int index = 0;
        // iteration through pixels
        for(int y = 0; y < height; ++y) {
            for(int x = 0; x < width; ++x) {
                // get current index in 2D-matrix
                index = y * width + x;
                // AND
                pixels[index] &= shadingColor;
            }
        }
        // output bitmap
        Bitmap bmOut = Bitmap.createBitmap(width, height, Bitmap.Config.ARGB_8888);
        bmOut.setPixels(pixels, 0, width, 0, 0, width, height);
        return bmOut;
    }
	
    public static final int SIZE = 3;

    public double[][] Matrix;
    public double Factor = 1;
    public double Offset = 1;

    public void ConvolutionMatrix(int size) {
        Matrix = new double[size][size];
    }

    public void setAll(double value) {
        for (int x = 0; x < SIZE; ++x) {
            for (int y = 0; y < SIZE; ++y) {
                Matrix[x][y] = value;
            }
        }
    }

    public void applyConfig(double[][] config) {
        for(int x = 0; x < SIZE; ++x) {
            for(int y = 0; y < SIZE; ++y) {
                Matrix[x][y] = config[x][y];
            }
        }
    }

    public Bitmap computeConvolution3x3(Bitmap src) {
        int width = src.getWidth();
        int height = src.getHeight();
        Bitmap result = Bitmap.createBitmap(width, height, src.getConfig());

        int A, R, G, B;
        int sumR, sumG, sumB;
        int[][] pixels = new int[SIZE][SIZE];

        for(int y = 0; y < height - 2; ++y) {
            for(int x = 0; x < width - 2; ++x) {

                // get pixel matrix
                for(int i = 0; i < SIZE; ++i) {
                    for(int j = 0; j < SIZE; ++j) {
                        pixels[i][j] = src.getPixel(x + i, y + j);
                    }
                }

                // get alpha of center pixel
                A = Color.alpha(pixels[1][1]);

                // init color sum
                sumR = sumG = sumB = 0;

                // get sum of RGB on matrix
                for(int i = 0; i < SIZE; ++i) {
                    for(int j = 0; j < SIZE; ++j) {
                        sumR += (Color.red(pixels[i][j]) * Matrix[i][j]);
                        sumG += (Color.green(pixels[i][j]) * Matrix[i][j]);
                        sumB += (Color.blue(pixels[i][j]) * Matrix[i][j]);
                    }
                }

                // get final Red
                R = (int)(sumR / Factor + Offset);
                if(R < 0) { R = 0; }
                else if(R > 255) { R = 255; }

                // get final Green
                G = (int)(sumG / Factor + Offset);
                if(G < 0) { G = 0; }
                else if(G > 255) { G = 255; }

                // get final Blue
                B = (int)(sumB / Factor + Offset);
                if(B < 0) { B = 0; }
                else if(B > 255) { B = 255; }

                // apply new pixel
                result.setPixel(x + 1, y + 1, Color.argb(A, R, G, B));
            }
        }

        // final image
        return result;
    }
	
		public int dp2px(int dip) {
		Resources resources = BA.applicationContext.getResources();
		int px = Math
				.round(TypedValue.applyDimension(TypedValue.COMPLEX_UNIT_DIP,
						dip, resources.getDisplayMetrics()));
		return px;
	}
	

	public int px2dp(int px) {
		DisplayMetrics displayMetrics = BA.applicationContext.getResources()
				.getDisplayMetrics();
		int dp = Math.round(px
				/ (displayMetrics.xdpi / DisplayMetrics.DENSITY_DEFAULT));
		return dp;
	}

	public int sp2px(float sp) {
		final float scale = BA.applicationContext.getResources().getDisplayMetrics().scaledDensity;
		int px = Math.round(sp * scale);
		return px;
	}	
	
	


	
	public static Bitmap getRoundBitmap(Bitmap scaleBitmapImage, int borderColor, int borderWidth) {
	int targetWidth = 1000;
	int targetHeight = 1000;
	int radius = Math.min((targetHeight - 5)/2, (targetWidth - 5)/2);   
	
	Bitmap targetBitmap = Bitmap.createBitmap(targetWidth, targetHeight,
			Bitmap.Config.ARGB_8888);

	Canvas canvas = new Canvas(targetBitmap);
	Path path = new Path();
	path.addCircle(((float) targetWidth - 1) / 2,
			((float) targetHeight - 1) / 2,
			(Math.min(((float) targetWidth), ((float) targetHeight)) / 2),
			Path.Direction.CCW);

	canvas.clipPath(path);
	
	Bitmap sourceBitmap = scaleBitmapImage;
	
	canvas.drawBitmap(sourceBitmap, new Rect(0, 0, sourceBitmap.getWidth(),
			sourceBitmap.getHeight()), new Rect(0, 0, targetWidth,
			targetHeight), null);
			
			
	Paint p = new Paint();                                              
	p.setAntiAlias(true);           		
	//	canvas.drawBitmap(sourceBitmap, 4, 4, p);                                      
	p.setXfermode(null);                                                
	p.setStyle(Paint.Style.STROKE);                                           
	p.setColor(borderColor);                                            
	p.setStrokeWidth(borderWidth);                                                
	canvas.drawCircle((targetWidth / 2) , (targetHeight / 2) , radius, p);      						

	return targetBitmap;
}

	public Bitmap drawRing2(Bitmap bitmap, int deltaRadius,
			int color, int bordercolor) {
		bitmap = squareImage(bitmap);		
		bitmap = toRoundCorner(bitmap,bordercolor);	
		int w = bitmap.getWidth();
		int dia = deltaRadius * 2 + w;
		float radius = (float) dia / 2;
		Bitmap resultBitmap = Bitmap.createBitmap(dia, dia, Config.ARGB_8888);
		Paint paint = new Paint();
		paint.setColor(color);
		paint.setAlpha(128);
		paint.setAntiAlias(true);
		Canvas canvas = new Canvas(resultBitmap);
		canvas.drawCircle(radius, radius, radius, paint);
		canvas.drawBitmap(bitmap, deltaRadius, deltaRadius, null);
		return resultBitmap;
	}
	
	public Bitmap toRoundCorner(Bitmap bitmap, int color) {
		try {
			int w = bitmap.getWidth();
			int h = bitmap.getHeight();
			final int delta = dp2px(10);
			final float roundPx = dp2px(28);
			final Paint paint = new Paint();
			paint.setAntiAlias(true);

			/* draw round foreground */
			int foreW = w - 2 * delta;
			int foreH = h - 2 * delta;
			Bitmap foreBmp = Bitmap
					.createBitmap(foreW, foreH, Config.ARGB_8888);
			Rect rect = new Rect(0, 0, foreW, foreH);
			RectF rectF = new RectF(rect);
			Canvas canvas0 = new Canvas(foreBmp);
			canvas0.drawRoundRect(rectF, roundPx, roundPx, paint);
			paint.setXfermode(new PorterDuffXfermode(Mode.SRC_IN));
			canvas0.drawBitmap(bitmap, null, rect, paint);

			/* draw round background */
			Drawable drawable = getDrawbale(color, (int) (delta + roundPx));
			drawable.setBounds(0, 0, w, h);
			Bitmap result = Bitmap.createBitmap(w, h, Config.ARGB_8888);
			Canvas canvas = new Canvas(result);
			drawable.draw(canvas);
			canvas.drawBitmap(foreBmp, delta, delta, null);

			return result;
		} catch (Exception e) {
			e.printStackTrace();
			return bitmap;
		}
	}

	public GradientDrawable getDrawbale(int argb, int radius) {
		GradientDrawable drawable = new GradientDrawable();
		drawable.setCornerRadius(radius);
		drawable.setColor(argb);
		return drawable;
	}
	
	public Bitmap toRounded(Bitmap bitmap,
			int color, int borderDips, int desireWidth) {
		try {
			Bitmap bitmap0 = squareImage(bitmap);
			Bitmap bitmap1 = resizeImage(bitmap0, desireWidth, desireWidth,
					true);
			int toPX = dp2px(borderDips);
			int maxBorder = (desireWidth / 2) / 5;
			maxBorder = maxBorder > 15 ? 15 : maxBorder;
			final int borderSizePx = toPX > maxBorder ? maxBorder : toPX;

			final int size = desireWidth;
			int center = (int) (size / 2);
			int left = (int) ((desireWidth - size) / 2);
			int top = (int) ((desireWidth - size) / 2);
			int right = left + size;
			int bottom = top + size;

			Bitmap output = Bitmap.createBitmap(size, size, Config.ARGB_8888);
			Canvas canvas = new Canvas(output);
			final Paint paint = new Paint();

			final Rect src = new Rect(left, top, right, bottom);
			final Rect dst = new Rect(0, 0, size, size);

			canvas.drawARGB(0, 0, 0, 0);
			// draw border
			paint.setColor(color);
			paint.setAntiAlias(true);
			int radius = center - borderSizePx;
			canvas.drawCircle(center, center, radius, paint);
			// draw bitmap
			paint.setXfermode(new PorterDuffXfermode(PorterDuff.Mode.SRC_IN));
			canvas.drawBitmap(bitmap1, src, dst, paint);
			paint.setXfermode(null);

			paint.setStyle(Paint.Style.STROKE);
			paint.setStrokeWidth((float) borderSizePx);
			radius = center - borderSizePx / 2;
			canvas.drawCircle(center, center, radius, paint);
			canvas.save();
			return output;
		} catch (Exception e) {
			e.printStackTrace();
		}
		return bitmap;
	}	
	
	
	
	
	
public Bitmap getHexagonShape(Bitmap scaleBitmapImage) {

      // TODO Auto-generated method stub

        int targetWidth = 300;
        int targetHeight = 300;
		

        Bitmap targetBitmap = Bitmap.createBitmap(targetWidth, targetHeight,Bitmap.Config.ARGB_8888);
        Canvas canvas = new Canvas(targetBitmap);
        Path path = new Path();
        float stdW = 300;
        float stdH = 300;
        float w3 =stdW / 2;
        float h2 = stdH / 2;
        path.moveTo(0, (float) (h2*Math.sqrt(3)/2));
        path.rLineTo(w3/2, -(float) (h2*Math.sqrt(3)/2)); path.rLineTo(w3, 0);   path.rLineTo(w3/2, (float) (h2*Math.sqrt(3)/2));
        path.rLineTo(-w3/2, (float) (h2*Math.sqrt(3)/2)); path.rLineTo(-w3, 0); path.rLineTo(-w3/2, -(float) (h2*Math.sqrt(3)/2));
        canvas.clipPath(path);
        Bitmap sourceBitmap = scaleBitmapImage;
        canvas.drawBitmap(sourceBitmap, new Rect(0, 0, sourceBitmap.getWidth(),
        sourceBitmap.getHeight()),new Rect(0, 0, targetWidth, targetHeight), null);
        return targetBitmap;

     }
	 
	 
public Bitmap getTriangleShape(Bitmap scaleBitmapImage) {

      // TODO Auto-generated method stub

        int targetWidth = 300;
        int targetHeight = 300;

        Bitmap targetBitmap = Bitmap.createBitmap(targetWidth, targetHeight,Bitmap.Config.ARGB_8888);
        Canvas canvas = new Canvas(targetBitmap);
        Path path = new Path();
        float stdW = 300;
        float stdH = 300;
        float w3 =stdW;
        float h2 = stdH;
		
        path.moveTo((float) w3/2, (float) 0.0);
        path.lineTo(w3, (float) h2); 
		path.lineTo((float)0.0, h2);   
		path.lineTo(w3/2, (float) 0.0);

        canvas.clipPath(path);
        Bitmap sourceBitmap = scaleBitmapImage;
        canvas.drawBitmap(sourceBitmap, new Rect(0, 0, sourceBitmap.getWidth(),
        sourceBitmap.getHeight()),new Rect(0, 0, targetWidth, targetHeight), null);
        return targetBitmap;

}

	 
public static Bitmap getBubbleBitmap(Bitmap scaleBitmapImage) {
	  int targetWidth = 1000;
	  int targetHeight = 1000;

	  Bitmap targetBitmap = Bitmap.createBitmap(targetWidth, targetHeight, Bitmap.Config.ARGB_8888);

	  Canvas canvas = new Canvas(targetBitmap);
	  Path path = new Path();

      path.moveTo((float) targetWidth/2, (float) 0.0);
      path.lineTo(targetWidth, (float) 0.0); 
	  path.lineTo((float)targetWidth, targetHeight/2);   

      RectF oval = new RectF();
	  oval.set(0, 0, targetWidth, targetHeight);
	  path.addArc(oval, 0, 270);
	  canvas.clipPath(path);
	
	  Bitmap sourceBitmap = scaleBitmapImage;
	  canvas.drawBitmap(sourceBitmap, new Rect(0, 0, sourceBitmap.getWidth(),
			sourceBitmap.getHeight()), new Rect(0, 0, targetWidth,
			targetHeight), null);
	  return targetBitmap;
}
	

public static Bitmap getConeBitmap(Bitmap scaleBitmapImage) {
	  int targetWidth = 1000;
	  int targetHeight = 1000;

	  Bitmap targetBitmap = Bitmap.createBitmap(targetWidth, targetHeight, Bitmap.Config.ARGB_8888);

	  Canvas canvas = new Canvas(targetBitmap);
	  Path path = new Path();

      path.moveTo((float) targetWidth, (float) targetHeight/2);
      path.lineTo(targetWidth/2, (float) targetHeight); 
	  path.lineTo((float)0.0, targetHeight/2);   

      RectF oval = new RectF();
	  oval.set(0, 0, targetWidth, targetHeight);
	  path.addArc(oval, 180, 180);  //from point 180 degree(9 o' clock position), go 180 degrees clockwise (to 3 o' clock position)
	  canvas.clipPath(path);
	
	  Bitmap sourceBitmap = scaleBitmapImage;
	  canvas.drawBitmap(sourceBitmap, new Rect(0, 0, sourceBitmap.getWidth(),
			sourceBitmap.getHeight()), new Rect(0, 0, targetWidth,
			targetHeight), null);
	  return targetBitmap;
}


public static Bitmap getStarBitmap (Bitmap scaleBitmapImage, int steps) {
	  int targetWidth = 1000;
	  int targetHeight = 1000;

	  Bitmap targetBitmap = Bitmap.createBitmap(targetWidth, targetHeight, Bitmap.Config.ARGB_8888);
	  Canvas canvas = new Canvas(targetBitmap);
	  Path path = new Path();

      float halfWidth = targetWidth / 2.0F;
      float bigRadius = halfWidth;
      float radius = halfWidth / 2.0F;
      float degreesPerStep = (float) Math.toRadians(360.0F / (float) steps);
      float halfDegreesPerStep = degreesPerStep / 2.0F;
	  
      Path ret = new Path();
      ret.setFillType(FillType.EVEN_ODD);
      float max = (float) (2.0F* Math.PI);
      ret.moveTo(targetWidth, halfWidth);
      for (double step = 0; step < max; step += degreesPerStep) {
        ret.lineTo((float)(halfWidth + bigRadius * Math.cos(step)), (float)(halfWidth + bigRadius * Math.sin(step)));
        ret.lineTo((float)(halfWidth + radius * Math.cos(step + halfDegreesPerStep)), (float)(halfWidth + radius * Math.sin(step + halfDegreesPerStep)));
      }
      ret.close();
	  canvas.clipPath(ret);
	
	  Bitmap sourceBitmap = scaleBitmapImage;
	  canvas.drawBitmap(sourceBitmap, new Rect(0, 0, sourceBitmap.getWidth(),
			sourceBitmap.getHeight()), new Rect(0, 0, targetWidth,
			targetHeight), null);
	  return targetBitmap;
}

public static Bitmap getHeartBitmap (Bitmap scaleBitmapImage) {
	  int targetWidth = 1000;
	  int targetHeight = 1000;
	  

	  Bitmap targetBitmap = Bitmap.createBitmap(targetWidth, targetHeight, Bitmap.Config.ARGB_8888);
	  
	  Canvas canvas = new Canvas(targetBitmap);
	  Path path = new Path();
      RectF oval = new RectF();
	  
	  oval.set(0, 0, targetWidth/2, targetHeight/2);
	  path.moveTo((float) 0.0, (float) oval.height()/2);
      path.addArc(oval, 0, 360);  //from point 180 degree(9 o' clock position), go 180 degrees clockwise (to 3 o' clock position)
      
      oval.set(targetWidth/2, 0, targetWidth, targetHeight/2);
	  path.moveTo((float) 0.0, (float) oval.height()/2);
      path.addArc(oval, 0, 360);  //from point 180 degree(9 o' clock position), go 180 degrees clockwise (to 3 o' clock position)
	  
	  path.moveTo((float) targetWidth-11, (float) (targetHeight*0.34));
      path.lineTo((float) targetWidth/2, (float) targetHeight); 
	  path.lineTo((float) 11, (float) (targetHeight*0.34)); 
	  
	  path.moveTo((float) 0.0, (float) (targetHeight*0.25));
	  path.lineTo((float) targetWidth, (float) (targetHeight*0.25));
	  path.lineTo((float) targetWidth/2, (float) targetHeight); 
	  path.lineTo((float) 0.0, (float) (targetHeight*0.25));
	  
	  
	  canvas.clipPath(path);
	
	  Bitmap sourceBitmap = scaleBitmapImage;
	  canvas.drawBitmap(sourceBitmap, new Rect(0, 0, sourceBitmap.getWidth(), sourceBitmap.getHeight()), new Rect(0, 0, targetWidth, targetHeight), null);
	  return targetBitmap;
}

public static Bitmap getCircledStar (Bitmap scaleBitmapImage) {

	int targetWidth = 1000;
	int targetHeight = 1000;

	Bitmap targetBitmap = Bitmap.createBitmap(targetWidth, targetHeight, Bitmap.Config.ARGB_8888);
	  
	Canvas canvas = new Canvas(targetBitmap);
	Path path = new Path();
    RectF oval = new RectF();

    Paint paint = new Paint();
    paint.setColor(Color.argb(255,0,0,200));
    paint.setAntiAlias(true);
    paint.setStyle(Paint.Style.STROKE);

    float mid = targetWidth / 2;
    float min = targetWidth;
    float fat = min / 17;
    float half = min / 2;
    float rad = half - fat;
    mid = mid - half;

    paint.setStrokeWidth(fat);
    paint.setStyle(Paint.Style.STROKE);

    canvas.drawCircle(mid + half, half, rad, paint);

    path.reset();

    paint.setStyle(Paint.Style.FILL);


        // top left
        path.moveTo(mid + half * 0.5f, half * 0.84f);
        // top right
        path.lineTo(mid + half * 1.5f, half * 0.84f);
        // bottom left
        path.lineTo(mid + half * 0.68f, half * 1.45f);
        // top tip
        path.lineTo(mid + half * 1.0f, half * 0.5f);
        // bottom right
        path.lineTo(mid + half * 1.32f, half * 1.45f);
        // top left
        path.lineTo(mid + half * 0.5f, half * 0.84f);

        path.close();
        canvas.clipPath(path);
      
	  Bitmap sourceBitmap = scaleBitmapImage;
	  
  
	  canvas.drawBitmap(sourceBitmap, new Rect(0, 0, sourceBitmap.getWidth(),
			sourceBitmap.getHeight()), new Rect(0, 0, targetWidth,
			targetHeight), null);
	  return targetBitmap;

}

    public Bitmap getRoundedCornerBitmap(Bitmap bitmap) {
	
		int w = bitmap.getHeight();                                          
		int h = bitmap.getHeight();                                         

		int radius = Math.min(h / 2, w / 2);                                
		Bitmap output = Bitmap.createBitmap(w + 8, h + 8, Bitmap.Config.ARGB_8888);

		Paint p = new Paint();                                              
		p.setAntiAlias(true);                                               

		Canvas c = new Canvas(output);                                      
		c.drawARGB(0, 0, 0, 0);                                             
		p.setStyle(Paint.Style.FILL);                                             

		c.drawCircle((w / 2) + 4, (h / 2) + 4, radius, p);                  

		p.setXfermode(new PorterDuffXfermode(Mode.SRC_IN));                 

		c.drawBitmap(bitmap, 4, 4, p);                                      
		p.setXfermode(null);                                                
		p.setStyle(Paint.Style.STROKE);                                           
		p.setColor(Color.BLUE);                                            
		p.setStrokeWidth(10);                                                
		c.drawCircle((w / 2) + 4, (h / 2) + 4, radius, p);                  

		return output;   
}




#End If