﻿Type=Class
Version=4.3
ModulesStructureVersion=1
B4A=true
@EndOfDesignText@
'Class module
Sub Class_Globals
	Private nativeMe As JavaObject
End Sub
'Initializes the object.
Public Sub Initialize
	nativeMe = Me
End Sub

'Returns an Integer array containing the following values:
'index 0 = year
'index 1 = month (1 = January, 2 = February, etc)
'index 2 = dayOfMonth
'index 3 = dayOfWeek (Sunday = 1, Monday = 2, etc)
'index 4 = weekOfYear
'index 5 = weekOfMonth
'index 6 = hour (12 hour format)
'index 7 = hourOfDay (24 hour format)
'index 8 = minute
'index 9 = second
'index 10 = millisecond
Public Sub now() As Int()

Dim dateAndTime(11) As Int
Dim dummy As Int = 1
dateAndTime = nativeMe.RunMethod("now",Array(dummy))
Return dateAndTime

End Sub

'Returns the time since January 1st 1970 in milliseconds. 
Public Sub timeNow() As Long

Dim longtime As Long
Dim dummy As Int = 1
longtime = nativeMe.RunMethod("timeNow",Array(dummy))
Return longtime

End Sub

'Returns the long name of the current day (eg Monday, Tuesday, etc) 
Public Sub nameOfDayLong() As String

Dim dayname As String
Dim dummy As Int = 1
dayname = nativeMe.RunMethod("nameOfDayLong",Array(dummy))
Return dayname

End Sub
'Returns the short name of the current day (eg Mon, Tue, etc) 
Public Sub nameOfDayShort() As String

Dim dayname As String
Dim dummy As Int = 1
dayname = nativeMe.RunMethod("nameOfDayShort",Array(dummy))
Return dayname

End Sub
'Returns a long date and time eg  Monday 27-Apr-2015 10:01 AM
Public Sub dateAndTimeLong() As String

Dim name As String
Dim dummy As Int = 1
name = nativeMe.RunMethod("dateAndTimeLong",Array(dummy))
Return name

End Sub

'Return the time zone ID's
Public Sub getTimeZoneIDs() As String()

Dim zoneID() As String
Dim dummy As Int = 1
zoneID = nativeMe.RunMethod("getTimeZoneIDs",Array(dummy))
Return zoneID

End Sub

'Return the time for the selected time zone ID
Public Sub getTheTime(place As String) As String

place = nativeMe.RunMethod("getTheTime",Array(place))
Return place

End Sub
'Return the DateTime stamp for the selected time zone ID
Public Sub getCurrentDateTimeStampForTimeZone(place As String) As String

place = nativeMe.RunMethod("getCurrentDateTimeStampForTimeZone",Array(place))
Return place

End Sub

'Return the DateTime stamp for the default date and time of your device
Public Sub getCurrentDateTimeStampForDefaultLocale() As String

Dim dummy As Int = 1
Dim defTime As String
defTime = nativeMe.RunMethod("getCurrentDateTimeStampForDefaultLocale",Array(dummy))
Return defTime

End Sub
'Return the time zone offset from GMT for your device
Public Sub getTimezoneOffsetforDefaultLocale() As String

Dim dummy As Int = 1
Dim timeOff As String
timeOff = nativeMe.RunMethod("getTimezoneOffsetforDefaultLocale",Array(dummy))
Return timeOff

End Sub
'Return the time zone offset from GMT for the selected time zone ID
Public Sub getTimezoneOffsetForSelectedTimeZoneID(place As String) As String

Dim timeOff As String
timeOff = nativeMe.RunMethod("getTimezoneOffsetForSelectedTimeZoneID",Array(place))
Return timeOff

End Sub

'Return the name of the default time zone eg "South Africa Standard Time"
Public Sub getNameOfDefaultTimeZone() As String

Dim dummy As Int = 1
Dim timeZoneName As String
timeZoneName = nativeMe.RunMethod("getNameOfDefaultTimeZone",Array(dummy))
Return timeZoneName

End Sub
'Return the abbreviated name of the default time zone eg "SAST" where SAST = South Africa Standard Time
Public Sub getAbbrevNameOfDefaultTimeZone() As String

Dim dummy As Int = 1
Dim timeZoneName As String
timeZoneName = nativeMe.RunMethod("getAbbrevNameOfDefaultTimeZone",Array(dummy))
Return timeZoneName

End Sub
'Return the abbreviated name of the selected time zone
Public Sub AbbrevNameOfSelectedTimeZone(place As String) As String

Dim timeZoneName As String
timeZoneName = nativeMe.RunMethod("AbbrevNameOfSelectedTimeZone",Array(place))
Return timeZoneName

End Sub
'Return the name of the selected time zone
Public Sub getNameOfSelectedTimeZone(place As String) As String

Dim timeZoneName As String
timeZoneName = nativeMe.RunMethod("getNameOfSelectedTimeZone",Array(place))
Return timeZoneName

End Sub

'Return the date and time as "dd:MM:yyyy:HH:mm:ss"
Public Sub dateFormat1() As String

Dim dummy As Int = 1
Dim timeFormat As String
timeFormat = nativeMe.RunMethod("dateFormat1",Array(dummy))
Return timeFormat

End Sub

'Return the date and time as "dd-MM-yyyy-HH-mm-ss"
Public Sub dateFormat2() As String

Dim dummy As Int = 1
Dim timeFormat As String
timeFormat = nativeMe.RunMethod("dateFormat2",Array(dummy))
Return timeFormat

End Sub

'Return the date and time as "dd-MMMM-yyyy-HH-mm-ss"
Public Sub dateFormat3() As String

Dim dummy As Int = 1
Dim timeFormat As String
timeFormat = nativeMe.RunMethod("dateFormat3",Array(dummy))
Return timeFormat

End Sub

'Return the date and time as "dd/MMM/yyyy/HH/mm/ss"
Public Sub dateFormat4() As String

Dim dummy As Int = 1
Dim timeFormat As String
timeFormat = nativeMe.RunMethod("dateFormat4",Array(dummy))
Return timeFormat

End Sub
'Return the date and time as "dd_MM_yy_HH_mm_ss a"
Public Sub dateFormat5() As String

Dim dummy As Int = 1
Dim timeFormat As String
timeFormat = nativeMe.RunMethod("dateFormat5",Array(dummy))
Return timeFormat

End Sub
'Return the date and time as "yyyy-MM-dd HH:mm:ss"
Public Sub dateFormat6() As String

Dim dummy As Int = 1
Dim timeFormat As String
timeFormat = nativeMe.RunMethod("dateFormat6",Array(dummy))
Return timeFormat

End Sub

'Returns a new date from the reference date by adding or subtracting days to/from the reference date
'Pass negative/positive values for daysToChange to decrease/increase the reference date
'year, month, and day is the reference date that should be passed
Public Sub addOrSubtractDays(year As Int, month As Int, day As Int, daysToChange As Int) As String

Dim newDate As String
newDate = nativeMe.RunMethod("addOrSubtractDays",Array(year, month, day, daysToChange))
Return newDate

End Sub


#If Java

import java.util.Calendar;
import java.util.GregorianCalendar;
import java.util.Date;
import java.text.SimpleDateFormat;
import java.util.Locale;
import java.text.DateFormat;
import java.util.TimeZone;
import java.util.concurrent.TimeUnit;

public int[] values;

public int[] now(int dummy) {
  values = new int[11];
  Calendar calendar = new GregorianCalendar();

  int year = calendar.get(Calendar.YEAR);
  values[0] = year;
  int month = calendar.get(Calendar.MONTH); 
  values[1] = month + 1;
  int dayOfMonth = calendar.get(Calendar.DAY_OF_MONTH); // Jan = 0, not 1
  values[2] = dayOfMonth;
  int dayOfWeek = calendar.get(Calendar.DAY_OF_WEEK);
  values[3] = dayOfWeek;
  int weekOfYear = calendar.get(Calendar.WEEK_OF_YEAR);
  values[4] = weekOfYear;
  int weekOfMonth = calendar.get(Calendar.WEEK_OF_MONTH);
  values[5] = weekOfMonth;

  int hour = calendar.get(Calendar.HOUR);        // 12 hour clock
  values[6] = hour;
  int hourOfDay = calendar.get(Calendar.HOUR_OF_DAY); // 24 hour clock
  values[7] = hourOfDay;
  int minute = calendar.get(Calendar.MINUTE);
  values[8] = minute;
  int second = calendar.get(Calendar.SECOND);
  values[9] = second;
  int millisecond= calendar.get(Calendar.MILLISECOND);
  values[10] = millisecond;  
  return values;
}

public long timeNow(int dummy) {
  long timeNow = System.currentTimeMillis();
  return timeNow;
}

public String nameOfDayLong (int dummy) {
  SimpleDateFormat sdf = new SimpleDateFormat("EEEE",Locale.getDefault());
  Date d = new Date();
  String dayOfTheWeek = sdf.format(d);
  return dayOfTheWeek;
}

public String nameOfDayShort (int dummy) {
  SimpleDateFormat sdf = new SimpleDateFormat("EEE",Locale.getDefault());
  Date d = new Date();
  String dayOfTheWeek = sdf.format(d);
  return dayOfTheWeek;
}

public String dateAndTimeLong (int dummy) {
	//global declaration
	
	Calendar calendar;

	calendar = Calendar.getInstance();
	//date format is:  "Date-Month-Year Hour:Minutes am/pm"
	SimpleDateFormat sdf = new SimpleDateFormat("dd-MMM-yyyy HH:mm a"); //Date and time
	String currentDate = sdf.format(calendar.getTime());

	//Day of Name in full form like,"Saturday", or if you need the first three characters you have to put "EEE" in the date format and your result will be "Sat".
	SimpleDateFormat sdf_ = new SimpleDateFormat("EEEE"); 
	Date date = new Date();
	String dayName = sdf_.format(date);
	return("" + dayName + " " + currentDate + "");
}


public String getTheTime(String place) {
  TimeZone zone = TimeZone.getTimeZone(place);
  DateFormat format = DateFormat.getDateTimeInstance();
  format.setTimeZone(zone);
  return(format.format(new Date()));
}  

public String[] getTimeZoneIDs(int dummy) {
  String[] ids = TimeZone.getAvailableIDs();
  return ids;
}

public String getCurrentDateTimeStampForTimeZone(String place) {
  SimpleDateFormat gmtDateFormat = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
  gmtDateFormat.setTimeZone(TimeZone.getTimeZone("GMT"));
  return gmtDateFormat.format(new Date()).toString();
}

public String getCurrentDateTimeStampForDefaultLocale(int dummy) {
  SimpleDateFormat gmtDateFormat = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
  gmtDateFormat.setTimeZone(TimeZone.getDefault());
  return gmtDateFormat.format(new Date()).toString();
}

public String getTimezoneOffsetforDefaultLocale(int dummy) {
    TimeZone tz = TimeZone.getDefault();  
    Calendar cal = GregorianCalendar.getInstance(tz);
    int offsetInMillis = tz.getOffset(cal.getTimeInMillis());
    String offset = String.format("%02d:%02d", Math.abs(offsetInMillis / 3600000), Math.abs((offsetInMillis / 60000) % 60));
    offset = "GMT"+(offsetInMillis >= 0 ? "+" : "-") + offset;
    return offset;
}

public String getTimezoneOffsetForSelectedTimeZoneID(String place) {
    TimeZone tz = TimeZone.getTimeZone(place);
    Calendar cal = GregorianCalendar.getInstance(tz);
    int offsetInMillis = tz.getOffset(cal.getTimeInMillis());
    String offset = String.format("%02d:%02d", Math.abs(offsetInMillis / 3600000), Math.abs((offsetInMillis / 60000) % 60));
    offset = "GMT"+(offsetInMillis >= 0 ? "+" : "-") + offset;
    return offset;
}

public String getNameOfDefaultTimeZone (int dummy) {
  Date now = new Date();
  TimeZone tz = Calendar.getInstance().getTimeZone();
  String name = tz.getDisplayName(tz.inDaylightTime(now), TimeZone.LONG);
  return name;
}  


public String getAbbrevNameOfDefaultTimeZone (int dummy) {
  Date now = new Date();
  TimeZone tz = Calendar.getInstance().getTimeZone();
  String name = tz.getDisplayName(tz.inDaylightTime(now), TimeZone.SHORT);
  return name;
}  

public String AbbrevNameOfSelectedTimeZone (String place) {
  Date now = new Date();
  TimeZone tz = TimeZone.getTimeZone(place);
  String name = tz.getDisplayName(tz.inDaylightTime(now), TimeZone.SHORT);
  return name;
}  

public String getNameOfSelectedTimeZone (String place) {
  Date now = new Date();
  TimeZone tz = TimeZone.getTimeZone(place);
  String name = tz.getDisplayName(tz.inDaylightTime(now), TimeZone.LONG);
  return name;
}  


public String dateFormat1 (int dummy) {
  Calendar c = Calendar.getInstance();
  SimpleDateFormat format1;
  format1 = new SimpleDateFormat("dd:MM:yyyy:HH:mm:ss ");
  return format1.format(c.getTime()).toString();
}

public String dateFormat2 (int dummy) {
  Calendar c = Calendar.getInstance();
  SimpleDateFormat format2;
  format2 = new SimpleDateFormat("dd-MM-yyyy-HH-mm-ss");
  return format2.format(c.getTime()).toString();
}

public String dateFormat3 (int dummy) {
  Calendar c = Calendar.getInstance();
  SimpleDateFormat format3;
  format3 = new SimpleDateFormat("dd-MMMM-yyyy-HH-mm-ss");
  return format3.format(c.getTime()).toString();
}

public String dateFormat4 (int dummy) {
  Calendar c = Calendar.getInstance();
  SimpleDateFormat format4;
  format4 = new SimpleDateFormat("dd/MMM/yyyy/HH/mm/ss");
  return format4.format(c.getTime()).toString();
}

public String dateFormat5 (int dummy) {
  Calendar c = Calendar.getInstance();
  SimpleDateFormat format5;
  format5 = new SimpleDateFormat("dd MMM yyyy HH:mm:ss a");
  return format5.format(c.getTime()).toString();
}

public String dateFormat6 (int dummy) {
  Calendar c = Calendar.getInstance();
  SimpleDateFormat format6;
  format6 = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
  return format6.format(c.getTime()).toString();
}

public String addOrSubtractDays (int year, int month, int day, int daysToChange) {
	SimpleDateFormat sdf = new SimpleDateFormat("yyyy MMM dd");	
	Calendar calendar = new GregorianCalendar(year,month-1,day);	
	calendar.add(Calendar.DAY_OF_MONTH, daysToChange);
	return sdf.format(calendar.getTime()).toString();
}


#End If