﻿Type=Class
Version=4.3
ModulesStructureVersion=1
B4A=true
@EndOfDesignText@
'Class module
Sub Class_Globals
	Private nativeMe As JavaObject
	
End Sub
'Initializes the object.
Public Sub Initialize
	nativeMe = Me
End Sub
'Vibrate continuously for the specified number of milliseconds
'
'You need to add the following to the manifest file of the B4A project:
'AddPermission("android.permission.VIBRATE")
Public Sub vibrateOnce (duration As Long)

nativeMe.RunMethod("vibrateOnce",Array(duration))

End Sub
'Vibrate with a given pattern. 
'Pass in an Array of Longs that are the durations for which to turn on or off the vibrator in milliseconds. 
'The first value indicates the number of milliseconds to wait before turning the vibrator on. The next 
'value indicates the number of milliseconds for which to keep the vibrator on before turning it off. 
'Subsequent values alternate between durations in milliseconds to turn the vibrator off or to turn the vibrator on.
'Parameters:
'pattern ---> an Array of longs of times for which to turn the vibrator on or off.
'repeat ---> the index into pattern at which to repeat, or -1 if you don't want to repeat.
'
'You need to add the following to the manifest file of the B4A project:
'AddPermission("android.permission.VIBRATE")
Public Sub vibratePattern (pattern() As Long, repeat As Int)

nativeMe.RunMethod("vibratePattern",Array(pattern, repeat))

End Sub
'Cancel vibration (in case of method vibratePattern being active)
'You need to add the following to the manifest file of the B4A project:
'AddPermission("android.permission.VIBRATE")
Public Sub vibrateCancel

Dim dummy As Int = 1
nativeMe.RunMethod("vibrateCancel",Array(dummy))

End Sub


#If Java

import android.os.Vibrator;
import android.content.Context;

/**
*Vibrate with a given pattern. 
*Pass in an array of Longs that are the durations for which to turn on or off the vibrator in milliseconds. 
*The first value indicates the number of milliseconds to wait before turning the vibrator on. The next 
*value indicates the number of milliseconds for which to keep the vibrator on before turning it off. 
*Subsequent values alternate between durations in milliseconds to turn the vibrator off or to turn the vibrator on.
*Parameters:
*pattern ---> an array of longs of times for which to turn the vibrator on or off.
*repeat ---> the index into pattern at which to repeat, or -1 if you don't want to repeat.
*
*You need to add the following to the manifest file of the B4A project:
*AddPermission("android.permission.VIBRATE")
*/
public void vibratePattern(long[] pattern, int repeat) {
    
  Vibrator v = (Vibrator) BA.applicationContext.getSystemService(Context.VIBRATOR_SERVICE);
  if (v.hasVibrator()) {
    v.vibrate(pattern, repeat);
  }
}

/**
*Cancel vibration (in case of method vibratePattern being active)
*You need to add the following to the manifest file of the B4A project:
*AddPermission("android.permission.VIBRATE")
*
*/
public void vibrateCancel(int dummy) {
    
  Vibrator v = (Vibrator) BA.applicationContext.getSystemService(Context.VIBRATOR_SERVICE);
  if (v.hasVibrator()) {
     v.cancel();
  }
}

/**
*Vibrate continuously for the specified number of milliseconds 
*You need to add the following to the manifest file of the B4A project:
*AddPermission("android.permission.VIBRATE")
*/
public void vibrateOnce(long duration) {
    
  Vibrator v = (Vibrator) BA.applicationContext.getSystemService(Context.VIBRATOR_SERVICE);
  if (v.hasVibrator()) {
     v.vibrate(duration);
  }
}



#End If
